#define ASSEMBLY

#include <stdio.h>
#include <string.h>
#include <dos.h>
#include <graphics.h>

#include "handler.h"
#include "gmcur.h"

#ifndef TRUE
#define TRUE -1
#define FALSE 0
#endif

#define EVENTMASK 0x54	//event when any button released

void demo(gcrec, char *);
void graphic_screen(char *);
void identify(char *);

int   driver = CGA, mode = CGAHI;
char path[]="C:\\TC\\BGI";

mouse *maus;

void main()
{
  initcurs();
  maus=new mouse;
  event_setup();

  if (maus->installed())
  {
    maus->install_task(EVENTMASK,FP_SEG(handler),FP_OFF(handler));

    graphic_screen("Default cursor");
    maus->show();
    me->reset();
    while(me->event==0);

    //show custom cursors
    demo(check,"Check");
    demo(left_arrow,"Left Arrow");
    demo(cross,"Cross");
    demo(hand,"Pointing hand");
    demo(ibeam,"Eyebeam");
    closegraph();
  }
}

void demo(gcrec cursor, char title[])
{
  identify(title);
  maus->graph_cursor(cursor.hot_x,cursor.hot_y, (unsigned) _DS,
		    (unsigned) cursor.image);
  me->reset();
  while(me->event==0);
}

void graphic_screen(char title[])
{
  int x,y;
  char prompt[30];

  initgraph(&driver, &mode, path);
  if (graphresult()==grOk)
  {
    identify(title);
    strcpy(prompt,"Click any button to continue");
    x=(getmaxx()-textwidth(prompt))/2;
    outtextxy(x,getmaxx()-20,prompt);

    setfillstyle(SOLID_FILL,1);
    setcolor(1);
    x=getmaxx()/2-50;
    y=getmaxy()/2-50;
    rectangle(x,y,x+100,y+100);
    floodfill(x+50,y+50,1);
  }
}

void identify(char title[])
{
  int x;
  setviewport(0,0,getmaxx(),30,TRUE);
  clearviewport();
  settextstyle(DEFAULT_FONT,HORIZ_DIR,1);
  x=(getmaxx()-textwidth(title))/2;
  outtextxy(x,20,title);
  setviewport(0,0,getmaxx(),getmaxy(),TRUE);
}
